Closure (API documentation of hlt.language packages)
Date: 2013-01-30

hlt.language.design.backend

## Class Closure

- java.lang.Object
- - hlt.language.design.backend.Block
  - - hlt.language.design.backend.Closure

- All Implemented Interfaces:
    RuntimeObject

      public class Closure
      extends Block

  A `Closure` object is to a `Block` object what an `Abstraction` expression is to a `Scope` expression. In other words, it is a `Block` with the added frame machinery.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `Closure(boolean isExitable, Instruction[] code, int address, int voidArity, int intArity, int realArity, int objectArity, int[] intFrame, double[] realFrame, java.lang.Object[] objectFrame)`
    `Closure(Instruction[] code, int address, int voidArity, int intArity, int realArity, int objectArity, int[] intFrame, double[] realFrame, java.lang.Object[] objectFrame)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `equals(java.lang.Object object)`
    `int` | `hashCode()`
    `int[]` | `intFrame()`
    `boolean` | `isExitable()`
    `java.lang.Object[]` | `objectFrame()`
    `double[]` | `realFrame()`
    `java.lang.String` | `toString()`

    - ### Methods inherited from class hlt.language.design.backend.Block

      `address, arity, code, intArity, objectArity, realArity, trueArity, voidArity`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### Closure

          public Closure(Instruction[] code,
                 int address,
                 int voidArity,
                 int intArity,
                 int realArity,
                 int objectArity,
                 int[] intFrame,
                 double[] realFrame,
                 java.lang.Object[] objectFrame)

    - #### Closure

          public Closure(boolean isExitable,
                 Instruction[] code,
                 int address,
                 int voidArity,
                 int intArity,
                 int realArity,
                 int objectArity,
                 int[] intFrame,
                 double[] realFrame,
                 java.lang.Object[] objectFrame)

  - ### Method Detail

    - #### isExitable

          public final boolean isExitable()

    - #### intFrame

          public final int[] intFrame()

    - #### realFrame

          public final double[] realFrame()

    - #### objectFrame

          public final java.lang.Object[] objectFrame()

    - #### equals

          public final boolean equals(java.lang.Object object)

      Overrides:
        `equals` in class `Block`

    - #### hashCode

          public final int hashCode()

      Overrides:
        `hashCode` in class `Block`

    - #### toString

          public final java.lang.String toString()

      Overrides:
        `toString` in class `Block`